 ;*************************************************************************************
 ;Martin Sigloch
 ;17. Oktober 2002
 ;*************************************************************************************
 ;
 ;TPS_LGTOBLOCK.LSP
 ;Dieses Tool erstellt einen Auswahlsatz ber eine Layergruppe und erzeugt daraus einen gleichnamigen Block
(prompt "\n--> Starten mit 'tps_lgtoblock'.")
(defun C:tps_lgtoblock (/ lold cmdold eold osold M:MD_ERR M:FEHLER)
   (setq M:MD_ERR *ERROR*
        *ERROR*  M:FEHLER
        ) ;_ end of setq
  ;;Marke fr Zurck nach Abbruch setzen
  (command "_.UNDO" "_MARK")
  (setq lold   (getvar "clayer")
        cmdold (getvar "cmdecho")
        eold   (getvar "menuecho")
        osold  (getvar "osmode")
        ) ;_ end of setq
  (setvar "menuecho" 0)
  (setvar "cmdecho" 0)
  (setq obj       (car
                    (entsel "\nObjekt in gewuenschter Layergruppe anklicken\n")
                    ) ;_ end of car
        obj       (entget obj)          ;Objektdatengruppen suchen
        objinsert (cdr (assoc 0 obj))
        )                               ;Gruppe 0 ist Objektbezeichnung
  (if (= objinsert "INSERT")
    (stop)
    (makeblock)
    )                                   ;Abfrage ob Objekt bereits ein Block ist
  ) ;_ end of defun

(defun makeblock (/ act-ctab la zeichen lg summla bp as)
  (setq act-ctab (getvar "CTAB")
        la       (cdr (assoc 8 obj))    ;Gruppe 8 ist Layername
        zeichen  (- (strlen la) 5)      ;subtrahiert von der Gesamtzahl der Zeichen den Wert 5 (z.B -am_7)
        lg       (substr la 1 zeichen)  ;reduziert die Zeichenkette auf "zeichen". Das erste Zeichen ist der Start der Zeichenkette.
        summla   (strcat lg "*")        ;fgt zum Layergruppennamen * hinzu
        bp       (getpoint "\nBasispunkt angeben \n")
        as       (ssget "X" (list (cons 8 summla)(cons 410 act-ctab))) ;holt alle Objekte der Layergruppe
        )                               
  (command "._-purge" "bl" lg "n" "._-block" lg bp as "") ;_ end of command ;Block wird erzeugt
  (setvar "osmode" 0)
  (if (/=(tblsearch "LAYER" (strcat lg "-am_0"))NIL)
    (setq inlay (strcat lg "-am_0"))
    (progn
      (Princ (strcat "\nDer Layer " lg "-am_0 Existiert nicht. Der Block wurde auf Layer 0 eingefgt!")) 
      (setq inlay "0")
      (command "._-Layer" "_u" "0" "")
      )
    )
  (command "._-layer"
           "_set"
           inlay
           ""                           ;Layergruppe wird gesetzt
           "._-insert"
           lg
           bp
           "1"
           "1"
           "0"
           )                            ;Block wird eingefgt
  (prompt "\nBlock wurde erzeut und eingefgt \n")
  (setvar "osmode" osold)
  (setvar "menuecho" eold)
  (setvar "cmdecho" cmdold)
  (command "._-layer" "_set" lold "")
  (princ)
  ) ;_ end of defun


(defun stop ()
  (prompt
    "\nDas gewhlte Element ist bereits ein Block - bitte prfen und auflsen"
    ) ;_ end of prompt
  (setvar "menuecho" eold)
  (setvar "cmdecho" cmdold)
  (command "._-layer" "_set" lold "")
  (princ)
  ) ;_ end of defun

 (defun M:FEHLER (MSG)
    (command "_.UNDO" "_BACK")
    (setq *ERROR* M:MD_ERR)
   (princ
     (strcat "Fehler! AutoCAD meldet: \"" MSG "\" als Ursache.")
      ) ;_ end of princ
    (princ)
    ) ;_ end of defun
